***May 2, 2013
***Johns Hopkins University Bloomberg School of Public Health 
***Lines ~5-237 create the database from multiple excel spreadsheets, lines from ~237+ do calculations
***Update the local below with date that future calculations are done.  Each version saved will update with that date
local DATE 05.02.13

**Set working directory

 
***CREATE DATABASE FROM EXCEL WORKSHEETS

**Insheet the excel spreadsheet that has initial population estimates, monthly IDP out migration for One year prior to the analysis period, and 750,000 "protracted" IDPs.  
**Subtract one year of IDP movements and protracted IDPs results in adjusted baseline estimate of population in each livelihood zone at beginning of the interval

insheet using "Somalia_BaselinePop.csv", comma

**Rename and reshape long

rename jun idp_609
rename jul idp_709
rename aug idp_809
rename sep idp_909
rename oct idp_1009
rename nov idp_1109
rename dec idp_1209
rename jan idp_110
rename feb idp_210
rename march idp_310
rename april idp_410
rename may idp_510

**Reshape command creates a single month/livelihood stratum observation for each row.  This is important for later matching strata with estimated monthly mortality rates

reshape long idp_, i(region livelihood) j(monthid)
**Each row is the original population estimate (pop2010-constant across all months for each livelihood zone (LZ), the original number of IDPs to subtract from 
*LZ based on 750,000 protracted IDPs (idp_baseline_750000-constant across all months for each LZ), the number of idps moving out each month (variable across months)
*and the adjusted baseline estimate of the population in each livelihood zone as of June 2010 (adj_base2010-constant across all months for each LZ)


**Generate month and year IDs to create date later in the code
gen month=round(monthid/100)
gen year=mod(monthid, 100)+2000

save Somalia_`DATE'_long.dta, replace

clear

**Insheet IDP movement dataset of monthly out-migrations of IDPs by livelihood zone (LZ)
insheet using "Somalia_IDPMovementMonthly.csv", comma

**Drop rows that are all missing but merge in from Excel
drop if location=="" & livelihood==""

**Rename dates for consistency 
foreach month of numlist 6/12{
rename idp_`month'_10 idp_`month'10
}

foreach month of numlist 1/6{
foreach year of numlist 11/12{
rename idp_0`month'_`year' idp_`month'`year'
}
}

foreach month of numlist 7/12{
rename idp_`month'_11 idp_`month'11
}

rename idp_07_12 idp_712

reshape long idp_, i(location region livelihood) j(monthid)
**Reshape long so that each month of IDP movements in each LZ is its own row
**Generate same months and years to append into previous dataset

gen month=round(monthid/100)
gen year=mod(monthid, 100)+2000

tempfile IDPsource
save `IDPsource', replace
use Somalia_`DATE'_long.dta

**Append to previous dataset.  Previous dataset was for months Jun 09-May 2010.  These are movements for Jun 2010-July 2012
append using `IDPsource'

**Sort by region and date
sort location region livelihood year month

**There are no estimates of out-migrations from the IDP zones per month so this is set to missing
replace idp_=. if livelihood=="idp"

**Clarify the difference between IDP zone population estimates and IDP out-migrations from LZs by renaming the number of IDPs out-migrating from LZs idpout
rename idp_ idpout

save, replace
clear

**Insheet the estimated numbers of refugees out-migrating (to Ethiopia and Kenya) from each livelihood zone each month
insheet using "Somalia_RefugeeMonthly.csv", comma
drop if location==""

**Rename dates for consistency and then reshape long.
rename ref_sub_e_6_1 ref_sub_e_6_10
foreach x in e k{
foreach month of numlist 6/12{
rename ref_sub_`x'_`month'_10 refsub_`x'_`month'10
}

foreach month of numlist 1/6{
foreach year of numlist 11/12{
rename ref_sub_`x'_`month'_`year' refsub_`x'_`month'`year'
}
}

foreach month of numlist 7/12{
rename ref_sub_`x'_`month'_11 refsub_`x'_`month'11
}
rename ref_sub_`x'_7_12 refsub_`x'_712
}

reshape long refsub_e_ refsub_k_, i(location region livelihood) j(monthid)

gen month=round(monthid/100)
gen year=mod(monthid, 100)+2000
tempfile RefugeeSource
save `RefugeeSource', replace

use Somalia_`DATE'_long.dta

**Merge in refugee numbers instead of appending because monthly refugee numbers are needed to subtract them from livelihood zones (though not IDP zones)
merge 1:1 region livelihood month year using `RefugeeSource', keepusing (refsub_e_ refsub_k_) nogen
**Unmatched observations are for months and livelihood zones that had no information regarding refugee movements (all prior to June 2010)
order region livelihood pop2010 adj_base2010 month year idpout refsub*
save, replace
clear

**Merge in IDP zone totals by month
insheet using "Somalia_IDPZonePopulation.csv", comma
tempfile IDPZone
save `IDPZone', replace

generate livelihood="idp"
drop district

**Reformat date to be compatible with previous format and reshape long
rename jun idpzone_609
rename jul idpzone_709
rename aug idpzone_809
rename sep idpzone_909
rename oct idpzone_1009
rename nov idpzone_1109
rename dec idpzone_1209
rename jan idpzone_110
rename feb idpzone_210
rename march idpzone_310
rename april idpzone_410
rename may idpzone_510

rensfix 2010_in 10
rensfix 2011_in 11
rensfix 2012_in 12

foreach year of numlist 10/12{
rename jun`year' idpzone_6`year'
rename jul`year' idpzone_7`year'
}

foreach year of numlist 10/11{
rename aug`year' idpzone_8`year'
rename sep`year' idpzone_9`year'
rename oct`year' idpzone_10`year'
rename nov`year' idpzone_11`year'
rename dec`year' idpzone_12`year'
}

foreach year of numlist 11/12{
rename jan`year' idpzone_1`year'
rename feb`year' idpzone_2`year'
rename mar`year' idpzone_3`year'
rename apr`year' idpzone_4`year'
rename may`year' idpzone_5`year'
}

reshape long idpzone_, i(region) j(monthid)
order livelihood, after(region)

gen month=round(monthid/100)
gen year=mod(monthid, 100)+2000

save `IDPZone', replace

use Somalia_`DATE'_long.dta

**Append data instead of merge as IDP zones will be treated as a new category (and strata) of livelihood zone
append using `IDPZone'
save, replace
clear

**Merge in CDRs and U5DRs
insheet using "Somalia_CDR_U5DR.csv", comma
rename m month
rename y year

**Rename region names for consistency between different sources
replace region="Galgudud" if region=="Galgadud"
replace region="Lower Juba" if region=="L. Juba"
replace region="Lower Shabelle" if region=="L. Shabelle"
replace region="Middle Juba" if region=="M. Juba"
replace region="Middle Shabelle" if region=="M. Shabelle"

tempfile MortalityRates
save `MortalityRates', replace

**Merge in the mortality rates by livelihood zone and month
use Somalia_`DATE'_long.dta
merge 1:1 region livelihood month year using `MortalityRates', nogen
**Not every month or livelihood zone had a rate calculated from survey data.  Our reference period is longer than the mortality
*estimation period because we also estimated population migration from the previous one year (June 2009-June 2010). Mortality rates 
*did not include any estimation prior to June 2010

save, replace
use Somalia_`DATE'_long.dta

**Based on merging, some of the variables have missing information.  This information is all the baseline information and can 
*be replaced with information from same region/LZ 
bysort region livelihood: replace pop2010=pop2010[_n-1] if pop2010==.
bysort region livelihood: replace adj_base2010=adj_base2010[_n-1] if adj_base2010==.
**Does not replace nonmissing data in IDPzone because baseline population was not estimated the same way as other livelihood zones
gen date=ym(year, month)
sort region livelihood date
bysort region livelihood: gen obs=_n
order obs, before(region)

***TOTAL POPULATION ESTIMATES
**Now using the current dataset to generate the growth model 
**There are three parts to the growth model each month: Out-migration, in-migration, and growth rate

**June 2010 is baseline
**July 2010 is baseline (adj_base2010) minus refugees to Ethiopia (resub_e_) minus refugees to Kenya (refsub_k) minus 
*IDP out-migration (idpout) plus IDP returns (IDP out from one year prior)

**Expose IDPs displaced since/as of June 2010 to estimated mortality rates and birth rates; 
*however for months prior to June 2010, we have no estimated survey-based mortality.  Thus, we use the standard UN rate of 15 per 1000 per year

*Apply monthly birth rates created from annual UN estimated CBR of 44 births per 1000 which closely matches survey-based rates of 43/1000
gen CBR=(44/12)/1000

**Reformat CDR provided from survey estimation from daily CDR into monthly CDR
gen CDR=cdrpred*3.04/1000
 
**For those months without estimated CDR, using annual UN CDR and reformatted into monthly death rate
replace CDR=(15/12)/1000 if CDR==.

**Generate growth rate
gen growth=CBR-CDR

sort region livelihood year month

**Replace missing idpout and refugee out values as 0
replace refsub_e_=0 if refsub_e_==.
replace refsub_k_=0 if refsub_k_==.
replace idpout=0 if idpout==.


**IDPs who are out-migrated from a livelihood zone are exposed to one year of IDP growth rates in the IDP zone to which they are displaced, after which they are returned to their original LZ

**Generate variables that are the number of people who left each month plus those added (or subtracted) according to the same month's growth rate in the IDP zone
**Generate the corresponding growth rates for each month in the IDP zones
**idpzonegrowth_0 = growth rate for the month that people left the IDP zone
**idpzonegrowth_1+ = growth rate for subsequent months 
order date, before(region)
replace region="Nugal" if region=="Nugaal"
replace region="Sanag" if region=="Sanaag"
tempfile SomaliaLong
save `SomaliaLong', replace

**Merge in IDP mortality rates for corresponding months
tempfile IDPmort
keep date region livelihood growth
keep if livelihood=="idp"
rename growth idpgrowth
save `IDPmort', replace
use `SomaliaLong'
merge m:1 date region using `IDPmort'
order idpgrowth, after(livelihood)
sort region livelihood date

**Generate the number of IDPs per each month based on growth rates
foreach num of numlist 0/11{
gen idpzonegrowth_`num'=idpgrowth[_n+38+`num'] 
}

**Generate the number of people, the number of births, the number of deaths for each month
gen idpout_n1=idpout

**Only do these calculations if the livelihood zone is NOT equal to IDP.  The IDP zone calculations will be done separately
if livelihood!="idp"{
foreach num of numlist 1/11{
local x=`num'+1

gen idpout_n`x'=idpout_n`num'+(idpout_n`num'*idpzonegrowth_`num')
gen idpoutbirth_n`num'=idpout_n`num'*CBR

}
}


drop idpzoneg* 
**The only numbers that are critical are the final idpout population counts.  They will be added 
*back into their original livelihood zones 12 months after departure

**IDP zone estimates have two components, one for protracted IDPs who remain in displacement for the entire analysis period, the other for monthly cohorts of in-migrating IDPs.  
**First, protracted IDPs as of baseline are grown to final month of analysis period, and births and deaths for each month are estimated
*starting with the numbers estimated as of baseline June 2010
rename baseline_idp_protracted protractidp

*start with only baseline IDP protracted and grow forward 
replace protractidp=. if monthid!=610
replace protractidp= protractidp[_n-1]+(protractidp[_n-1]*growth[_n-1]) if livelihood=="idp" & protractidp==.
gen protractdeaths=protractidp*CDR
gen protractbirths=protractidp*CBR

**Second, each cohort of in-migrating IDPs is exposed to 12 months of death and birth rates.  On the assumption that arrivals took place across the month,
*in the first month of displacement we applied one half a month of IDP growth rates 

**In-migrating IDPs are cumulated each month and added to protracted population to get total IDP zone population and apply month-specific growth rates
foreach month of numlist 594/630{
**generate the growth rates per each month cohort into IDP zone as they grow through the analysis period
gen idppop`month'=idpzone_ if date==`month'
replace idppop`month'=idppop`month'[_n-1]+(idppop`month'[_n-1]*growth[_n-1]*.5) if date==`month'+1
replace idppop`month'=idppop`month'[_n-1]+(idppop`month'[_n-1]*growth[_n-1]) if (date>`month'+1 & date<=`month'+11)
gen idpdeath`month'=idppop`month'*.5*CDR if date==`month'
replace idpdeath`month'=idppop`month'*CDR if date>`month'
gen idpbirth`month'=idppop`month'*.5*CBR if date==`month'
replace idpbirth`month'=idppop`month'*CBR if date>`month'
}

**For each month, total the number of protracted IDPs and the estimated number of IDPs in each month arrival cohort
**Do this for total population, deaths, and births
egen idpzonepoptotal=rowtotal(idppop* protractidp)
egen idpzonedeathtotal=rowtotal(idpdeath* protractdeaths)
egen idpzonebirthtotal=rowtotal(idpbirth* protractbirths)
order idpzone*, before (cdrpred)

**Generate LZ population at the beginning of the month (lzmonthstart) 

**Replace missing idpout and refugee out values as 0
replace refsub_e_=0 if refsub_e_==.
replace refsub_k_=0 if refsub_k_==.
replace idpout=0 if idpout==.

**apply growth rates to the LZs, not IDP
**generate initial LZ population at the beginning of the interval (lzmonthstart) 
if livelihood!="idp"{

gen lzmonthstart=.
replace lzmonthstart=adj_base2010 if date==605
order lzmonthstart, after(adj_base2010)

**Subtract the IDPs and refugees
gen lzpopsub=lzmonthstart-idpout-refsub_e_-refsub_k_ if date==605
order lzpopsub, after(lzmonthstart)

**Apply the growth rate to see how many people are added (or subtracted)
gen lzpopadd=lzpopsub*growth
gen lzmonthdead=lzpopsub*CDR
gen lzmonthbirth=lzpopsub*CBR
order lzpopadd lzmonthdead lzmonthbirth, after(lzpopsub)

**Add (population after outmigrants are subtracted) + (people added by growth rate) + (IDPs returning 12 months later (after exposure to growth rates))
gen lzmonthend=lzpopsub+lzpopadd + idpout_n12[_n-12]
order lzmonthend, after(lzpopadd)

**Automate for all the rest of the months so that each month grows from the previous month

foreach num of numlist 14/38{
replace lzmonthstart=lzmonthend[_n-1] if obs==`num'
replace lzpopsub=lzmonthstart-idpout-refsub_e_-refsub_k_ 
replace lzpopadd=lzpopsub*growth
replace lzmonthdead=lzpopsub*CDR
replace lzmonthbirth=lzpopsub*CBR
replace lzmonthend=lzpopsub+lzpopadd+idpout_n12[_n-12]

}
}

**Label variables for clarity 
label var lzmonthstart "Population in LZ at beginning of the month"
label var lzpopsub "Population after IDPs and refugees are subtracted"
label var lzpopadd "Number of people to add based on growth rate times lzpopsub"
label var lzmonthend "Population after people added from growth rates AND returned IDPs"
label var lzmonthdead "People who died each month based on lzpopsub times CDR"
label var lzmonthbirth "People who who were born each month based on lzpopsub times CBR"
label var idpout "Number of IDPs moved out of LZ"
label var refsub_e_ "Number of refugees moved out to Ethiopia"
label var refsub_k_ "Number of refugees moved out to Kenya"
label var protractidp "Number of protracted IDPs (750,000 proportionally allocated)"
label var idpzone_ "Population into IDPzone each month"
label var idpzonepoptotal "Total Population in IDP zone  (protracted plus one year cohorts incoming IDPs"
label var idpzonedeathtotal "Total dead during month in IDP zone (protracted plus one year cohorts)"
label var idpzonebirthtotal "Total births during month in IDP zone (protracted plus one year cohorts)"
label var idpout_n1 "Growth rates of IDPs moved out"
label var protractdeaths "Number of deaths to protracted population in IDP zone"
label var protractbirths "Number of births to protracted population in IDP zone"
foreach date of numlist 594/630{
label var idppop`date' "Population of cohort per month"
label var idpdeath`date' "Number of deaths to cohort in month"
label var idpbirth`date' "Number of births to cohort in month"
}


save Somalia_Model1_`DATE'.dta, replace

***UNDER-5 POPULATION
**These steps replicate the majority of the steps above, just specific to the under-5 population 

**For under 5s, the starting figures is assumed to be 25% of the total population(25% being the median under 5 proportion in the surveys).
*Furthermore, it is assumed that the proportion displaced on any given month from any stratum is the same for under 5s as for the 
*general population

*Create initial under-5 populations
gen u5base=.25*adj_base2010
gen u5idpout=idpout*.25
gen u5idpzone_=idpzone_*.25

*Reformat u5mortality to monthly
gen u5DR=u5drpred*3.04/1000
**Where survey estimated U5DR not available, use UN estimate 180/1000 calculated as a monthly rate
replace u5DR=((180/60)/1000) if u5DR==.

tempfile Somaliau5Long
save `Somaliau5Long', replace
tempfile IDPmortu5
keep date region livelihood u5DR
keep if livelihood=="idp"
rename u5DR u5DRidp
save `IDPmortu5', replace
use `Somaliau5Long'
merge m:1 date region using `IDPmortu5', nogen
order u5DRidp, after(idpgrowth)
sort region livelihood date

foreach num of numlist 0/11{
gen u5idpzoneu5DR_`num'=u5DRidp[_n+38+`num'] 
}


**To get the number of under5s, we add the number of under5 from the month before to the number of births based on the CbR, 
*subtract the number dead based on under-5 and subtract 1/59 of the pop who have aged out (There are 59 months between 
*being born and turning five.  Assume that 1/59 of the under-5 is thus aging out each month)
gen u5idpout_n1=u5idpout
if livelihood!="idp"{
foreach num of numlist 1/11{
local x=`num'+1
gen u5idpout_n`x'=u5idpout_n`num'+idpoutbirth_n`num'-(u5idpout_n`num'*u5idpzoneu5DR_`num')-(1/59*u5idpout_n`num')
}
}
 
**start with only baseline protracted and accumulate forward (not accumulating previous to baseline because these are the numbers estimated protracted at baseline
**For each consecutive month, the number under5 is the number of the month before, plus those born in that month, minus those who died, minus the 1/59 who age out
gen u5protractidp=protractidp*.25 if monthid==610
replace u5protractidp= u5protractidp[_n-1]-(u5protractidp[_n-1]*u5DR[_n-1]) + protractbirths[_n-1] - 1/59*u5protractidp[_n-1]  if livelihood=="idp" & u5protractidp==.
gen u5protractdeaths=u5protractidp*u5DR


**Each round of in-migrating IDPs is exposed to 12 months of mortality and birth rates (for first month, applied the rates divided by 2 since it is assumed they arrive halfway through on average)
**These can be cumulated each month by each cohort into IDP zone, apply death rates for one month to estimate deaths, add birhts, subtract 1/59
foreach month of numlist 594/630{
**Generate the growth, number of birth, and number of deaths per each month cohort into IDP zone as they grow through the interval
gen u5idppop`month'=u5idpzone_ if date==`month'
replace u5idppop`month'=u5idppop`month'[_n-1]-(u5idppop`month'[_n-1]*u5DR[_n-1]*.5) + idpbirth`month'[_n-1]*.5 if date==`month'+1
replace u5idppop`month'=u5idppop`month'[_n-1]-(u5idppop`month'[_n-1]*u5DR[_n-1]) + idpbirth`month'[_n-1] - 1/59*u5idppop`month'[_n-1] if (date>`month'+1 & date<=`month'+11)
gen u5idpdeath`month'=u5idppop`month'*.5*u5DR if date==`month'
replace u5idpdeath`month'=u5idppop`month'*u5DR if date>`month'
}

*Total across the arrival cohorts and protracted IDPs to get populations and death counts
egen u5idpzonepoptotal=rowtotal(u5idppop* u5protractidp)
egen u5idpzonedeathtotal=rowtotal(u5idpdeath* u5protractdeaths)

**Generate u5LZ population at the beginning of the month (lzmonthstart) 

**Apply growth rates to the LZs, not IDP
**Generate LZ population at the beginning of the month (lzmonthstart) 
if livelihood!="idp"{

gen u5lzmonthstart=.
replace u5lzmonthstart=u5base if date==605

**Subtract the IDPs and refugees
gen u5lzpopsub=u5lzmonthstart-u5idpout-.25*(refsub_e_)-.25*(refsub_k_) if date==605

**Generate the number under5 who died in the first month
gen u5lzmonthdead=u5lzpopsub*u5DR

**Add (population after outmigrants are subtracted) +births based on CDR-deaths +number under 5 who came back from IDP-the number who aged out
gen u5lzmonthend=u5lzpopsub-u5lzmonthdead + lzmonthbirth-u5idpout_n12[_n-12] - 1/59*u5lzpopsub

**Automate for all the rest of the months

foreach num of numlist 14/38{
replace u5lzmonthstart=u5lzmonthend[_n-1] if obs==`num'
replace u5lzpopsub=u5lzmonthstart-u5idpout-.25*refsub_e_-.25*refsub_k_ 
replace u5lzmonthdead=u5lzpopsub*u5DR
replace u5lzmonthend=u5lzpopsub - u5lzmonthdead + lzmonthbirth +u5idpout_n12[_n-12] -1/59*u5lzpopsub

}
}

order u5lzmonthstart u5lzpopsub u5lzmonthdead u5lzmonthend, after(lzmonthbirth)


**Drop unneccessary variables
drop idpout_n1-idpoutbirth_n11 idppop594-idpbirth630 u5idpzoneu5DR_0-u5idpzoneu5DR_11 u5idpout-u5idpout_n11 u5idppop594-u5idpdeath630

*Drop livelihood zones (Somaliland and Puntland) that do not have corresponding survey mortality rate as these will not be used 
*in mortality estimation analysis.  

drop if cdrpred==.
keep obs-livelihood lzmonthstart u5lzmonthstart idpzonepoptotal u5idpzonepoptotal


*****
label var u5lzmonthstart "Number of under5 in the beginning of the month"

save Somalia_PopulationEstimates_`DATE'.dta, replace


